#!D:\perl\bin\perl.exe
#
# Adventure Generator v0.1
#
# JL
#

use Tk;

$mainWindow = MainWindow->new;
$mainWindow->title("Adventure Generator for Dungeons and Dragons");

$adventureNameLabel = $mainWindow->Label(-text => "Adventure Name:")->pack(-side => 'top', -anchor => 'ne');
$adventureNameEntry = $mainWindow->Entry(-relief => "ridge")->pack(-side => 'top', -anchor => 'ne');

$characterLevelLabel = $mainWindow->Label(-text => "Total Character Levels:")->pack(-side => 'top', -anchor => 'nw');
$characterLevelEntry = $mainWindow->Entry(-relief => "ridge")->pack(-side => 'top', -anchor => 'nw');

$textArea = $mainWindow->Text(-width => 60, -height => 10)->pack;

$mainWindow->Button(-text => "Quit", -command => sub { exit })->pack(-padx => 80, -side => 'left', -anchor => 's');
$mainWindow->Button(-text => "Enter", -command => sub { enter()})->pack(-padx => 80, -side => 'right', -anchor => 's');
$mainWindow->Button(-text => "Save", -command => sub { save() })->pack(-padx => 40, -side => 'right', -anchor => 's');

MainLoop;

sub save
{
$adventureName = $adventureNameEntry->get();
$adventureName = $adventureName.".txt";
$adventure = $textArea->get("1.0", 'end');

open(GAME, ">$adventureName");

# Output to file

print GAME ("Adventure Generator v0.1\n");

print GAME ("\n$adventure");

close(GAME);
}

sub enter
{
$textArea->delete("1.0", 'end');

$adventureName = $adventureNameEntry->get();
$characterLevels = $characterLevelEntry->get();

$adventureName = $adventureName.".txt";

# Array definitions

# Villan Race, Class, Level, Lair, 

@villanClass = ("mage", "necromancer", "cleric", "fighter", "thief", "illusionist", 
                "monk", "sorcerer", "barbarian", "paladin");
@villanRace = ("elf", "dwarf", "human", "dragon", "half-orc", "tanar-ri", "baatezu",
               "lich", "doppleganger", "human", "half-elf", "elf", "mind-flayer", 
               "mummy", "rakshasa", "spectre", "wraith", "human", "elf", "halfling", 
               "gnome", "human");
@villanLair = ("castle", "mansion", "cave", "dungeon", "ruin");
@villanLaw = ("L", "N", "C");
@villanGood = ("G", "N", "E");

srand;
$randomRace = rand(@villanRace);
srand;
$randomLaw = rand(@villanLaw);
srand;
$randomGood = rand(@villanGood);
srand;
$randomLair = rand(@villanLair);

srand;
$villanChanceToHaveClassIfNotAStandardRace = rand(100);
srand;
$randomRace2 = rand(@villanRace);

if($villanRace[$randomRace2] eq "human" || $villanRace[$randomRace2] eq "elf" ||
   $villanRace[$randomRace2] eq "gnome" || $villanRace[$randomRace2] eq "halfling" ||
   $villanRace[$randomRace2] eq "dwarf" || $villanRace[$randomRace2] eq "half-orc" ||
   $villanRace[$randomRace2] eq "half-elf" || $villanChanceToHaveClassIfNotAStandardRace == 1)
{
   srand;
   $randomClass = rand(@villanClass);
   $villanClass[666] = $villanClass[$randomClass];
   $villanLevel = "Level ".int($characterLevels - rand($characterLevels / 2));
} else {
   $villanClass[666] = "";
   $villanLevel = "";
}

$textArea->Insert("Villan: $villanLaw[$randomLaw]$villanGood[$randomGood] $villanRace[$randomRace] $villanLevel $villanClass[666]");
$textArea->Insert("\nVillan's Lair: $villanLair[$randomLair]");

@benefactor = ("mage", "fighter", "bard", "cleric", "sorcerer", "sage", "commoner", "baron", "king", "mayor", "knight", 
               "child", "old man", "farmer", "blacksmith", "wizard");

@goals = ("defeat the villan", "find", "save benefactor from villan");

srand;
$randomBenefactor = rand(@benefactor);
srand;
$randomGoal = rand(@goals);

if($goals[$randomGoal] eq "find")
{
   srand;
   $singleTest = rand(2);
   
   if($singleTest >= 1)
   {
      @items = ("the ring", "the sword", "the orb", "the scroll", "the wand", "the staff", "the armor", 
                "the shield");

      srand;
      $randomItem = rand(@items);

      $itemAmount = "";

   } else {

      srand;
      $itemAmount = int(rand(10)); 

      @items = ("gems", "staff pieces", "orbs", "coins"); 


   }


   srand; srand;
   $randomItem = rand(@items);

   @itemTypes = ("of the demons", "of the evil mage", "of the god of magic", "of fire", "of water", 
                 "of earth", "of the forest", "of the nine hells", "of olympus");
 
   srand;
   $randomItemType = rand(@itemTypes);

   $goals[$randomGoal] = $goals[$randomGoal]." $itemAmount $items[$randomItem] $itemTypes[$randomItemType]";
}

$textArea->Insert("\n\nBenefactor: $benefactor[$randomBenefactor]\n\nGoal: $goals[$randomGoal]");

}